'Icon Editor for LB3
'by Alyce Watson
'copyright alycewatson@charter.net

'Similar to Icon Editor in LB Workshop
'(http://alycesrestaurant.com/workshop.htm)
'but with fewer features.

'Will load and display icons.
'Will save icons as 16-color.
'Color reduction to 16 colors.
'Save as bmp now available.
'Can write icon to runtime engine.

vers=val(Version$)
if (vers<3) or (vers>3.9) then
    notice "LB3 only!"
    end
end if

    backcolor$="white"
    modifyFlag=0      'has icon been modified?
    justPath$=DefaultDir$+"\"

    DIM k(15)         'make a palette
    k(15)=0           'black
    k(14)=8421504     'darkgray
    k(13)=12632256    'lightgray
    k(12)=16777215    'white
    k(11)=8388608     'darkblue
    k(10)=16711680    'blue
    k(9)=32768        'darkgreen
    k(8)=65280        'green
    k(7)=8421376      'darkcyan
    k(6)=16776960     'cyan
    k(5)=32896        'brown
    k(4)=65535        'yellow
    k(3)=127          'darkred
    k(2)=255          'red
    k(1)=8388736      'darkpink
    k(0)=16711935     'pink


    DIM k$(15)        'set values for palette entries in hex
    for i = 0 to 9
        k$(i)=str$(i)
    next i
    k$(10)="A"
    k$(11)="B"
    k$(12)="C"
    k$(13)="D"
    k$(14)="E"
    k$(15)="F"

'write the ico file header for 16-color icon, using palette above
    head$="0 0 1 0 1 0 32 32 16 0 0 0 0 0 232 2 0 0 22 0 0 0 40 0 0 0 32 0 0 0 64 0 0 0 1 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 0 255 0 128 0 128 0 0 0 255 0 0 0 128 0 0 255 255 0 0 128 128 0 255 255 0 0 128 128 0 0 0 255 0 0 0 128 0 0 255 0 0 0 128 0 0 0 255 255 255 0 192 192 192 0 128 128 128 0 0 0 0 0 0 0 "
    DIM header(127)
    for i=1 to 127
        header(i)=val(word$(head$,i))
    next i

    header(111)=0  'for transparent color
    header(112)=0
    header(113)=0

    head$="" 'free memory


    WindowWidth = 576
    WindowHeight = 390
    UpperLeftX=1:UpperLeftY=1
    nomainwin

    button #main.new, "New Icon",     [iconnew],     UL,460,10,100,24
    button #main.open, "Open",        [iconopen],    UL,460,40,100,24
    button #main.save, "Save as Icon",[iconsave],    UL,460,70,100,24
    button #main.save2, "Save as Bmp",[biconsave],   UL,460,100,100,24
    button #main.exit, "Exit",        [iconexit],    UL,460,130,100,24
    button #main.run, "Runtime Icon", [runtimeIcon], UL,460,160,100,24
    button #main.help, "Help",        [iconhelp],    UL,460,190,50,24
    button #main.about, "About",      [iconabout],   UL,510,190,50,24

    checkbox #main.pixel,"Single Pixel",   [iconpixel],[iconloop],460,226,80,22
    checkbox #main.all,"Change All",       [iconall],  [iconloop],460,250,80,22
    checkbox #main.flood, "Flood Fill",    [iconflood],[iconloop],460,274,80,22
    radiobutton #main.tr, "white = trans.",[transparent],[iconloop], 460,302,170,30
    radiobutton #main.op, "white = opaque",[opaque],[iconloop], 460,326,170,30

    graphicbox #main.g, 0,0,450,350
    open "16-Color Icon Tool" for window_nf as #main
    print #main, "trapclose [iconexit]"
    Handle=hwnd(#main.g)

    print #main,       "font arial 8"
    print #main.g,     "font arial 0 14"
    print #main.pixel, "set"

    Calldll #user32, "GetDC", Handle as long, iconhdc as long
    calldll #user32, "GetWindowLongA",Handle as long, _GWL_HINSTANCE as long, hCurrentInst as long

    PixColor=256*256*256 + 256*256 + 256 'white
    cl=256*256*65 + 256*65 + 65 'almost black for grid lines
    CallDll #gdi32, "GetNearestColor",iconhdc as long, cl as long, cl as long
    gridred=GetRed(cl):gridgreen=GetGreen(cl):gridblue=GetBlue(cl)

    print #main.tr, "set"
    print #main.g, "down;fill white"
    print #main.g, "color 65 65 65;backcolor white;place 400 0;boxfilled 500 20"
    print #main.g, "backcolor lightgray;place 400 20;boxfilled 500 40"
    print #main.g, "backcolor darkgray;place 400 40;boxfilled 500 60"
    print #main.g, "backcolor black;place 400 60;boxfilled 500 80"
    print #main.g, "backcolor yellow;place 400 80;boxfilled 500 100"
    print #main.g, "backcolor brown;place 400 100;boxfilled 500 120"
    print #main.g, "backcolor green;place 400 120;boxfilled 500 140"
    print #main.g, "backcolor darkgreen;place 400 140;boxfilled 500 160"
    print #main.g, "backcolor red;place 400 160;boxfilled 500 180"
    print #main.g, "backcolor darkred;place 400 180;boxfilled 500 200"
    print #main.g, "backcolor blue;place 400 200;boxfilled 500 220"
    print #main.g, "backcolor darkblue;place 400 220;boxfilled 500 240"
    print #main.g, "backcolor cyan;place 400 240;boxfilled 500 260"
    print #main.g, "backcolor darkcyan;place 400 260;boxfilled 500 280"
    print #main.g, "backcolor pink;place 400 280;boxfilled 500 300"
    print #main.g, "backcolor darkpink;place 400 300;boxfilled 500 320;flush"
    gosub [grid]
    FileName$="UNTITLED.ICO"
    gosub [print.name]
    gosub [flush.icon]

    getX=410
    k(15)=GetPixel(iconhdc,getX,70)  'black
    k(14)=GetPixel(iconhdc,getX,50)  'darkgray
    k(13)=GetPixel(iconhdc,getX,30)  'lightgray
    k(12)=GetPixel(iconhdc,getX,10)  'white
    k(11)=GetPixel(iconhdc,getX,230) 'darkblue
    k(10)=GetPixel(iconhdc,getX,210) 'blue
    k(9)=GetPixel(iconhdc,getX,150)  'darkgreen
    k(8)=GetPixel(iconhdc,getX,130)  'green
    k(7)=GetPixel(iconhdc,getX,270)  'darkcyan
    k(6)=GetPixel(iconhdc,getX,250)  'cyan
    k(5)=GetPixel(iconhdc,getX,110)  'brown
    k(4)=GetPixel(iconhdc,getX,90)   'yellow
    k(3)=GetPixel(iconhdc,getX,190)  'darkred
    k(2)=GetPixel(iconhdc,getX,170)  'red
    k(1)=GetPixel(iconhdc,getX,310)  'darkpink
    k(0)=GetPixel(iconhdc,getX,290)  'pink


[iconloop]
    print #main.g, "setfocus; when leftButtonDown [mouse.down]"
    print #main.g, "when leftButtonMove [mouse.down]"
    print #main.g, "backcolor ";backcolor$
    print #main.g, "place 5 80;boxfilled 45 120"
    Input a$ 

[transparent]'make white transparent
    icopaque=0
    header(111)=0  'for transparent color = black
    header(112)=0
    header(113)=0
    goto [iconloop]

[opaque]'make white opaque
    icopaque=1
    header(111)=255    'make white = opaque white
    header(112)=255
    header(113)=255
    goto [iconloop]

[iconpixel]'color single pixel
    changeall=0
    print #main.all, "reset"
    print #main.flood, "reset"
    goto [iconloop]

[iconall]'change all instances of a color
    changeall=1
    print #main.pixel, "reset"
    print #main.flood, "reset"
    goto [iconloop]

[iconflood]'flood fill
    changeall=2
    print #main.all, "reset"
    print #main.pixel, "reset"
    goto [iconloop]


[mouse.down]'check mouse location and draw, or change drawing color
    if MouseX<60  OR MouseY<0 OR MouseY>320 then [iconloop]
    if MouseX>60 and MouseX<380 then [put.color]
    if MouseX>400 then [get.color]
    goto [iconloop]


[get.color] 'determine desired drawing color from palette
    calldll #gdi32, "GetPixel",iconhdc AS long, MouseX AS long,MouseY AS long, PixColor AS long
    MY=MouseY
    if MY<20 then backcolor$="white":goto [iconloop]
    if MY<40 then backcolor$="lightgray":goto [iconloop]
    if MY<60 then backcolor$="darkgray":goto [iconloop]
    if MY<80 then backcolor$="black":goto [iconloop]
    if MY<100 then backcolor$="yellow":goto [iconloop]
    if MY<120 then backcolor$="brown":goto [iconloop]
    if MY<140 then backcolor$="green":goto [iconloop]
    if MY<160 then backcolor$="darkgreen":goto [iconloop]
    if MY<180 then backcolor$="red":goto [iconloop]
    if MY<200 then backcolor$="darkred":goto [iconloop]
    if MY<220 then backcolor$="blue":goto [iconloop]
    if MY<240 then backcolor$="darkblue":goto [iconloop]
    if MY<260 then backcolor$="cyan":goto [iconloop]
    if MY<280 then backcolor$="darkcyan":goto [iconloop]
    if MY<300 then backcolor$="pink":goto [iconloop]
    if MY<320 then backcolor$="darkpink":goto [iconloop]
    backcolor$="darkpink":goto [iconloop]   'default
    gosub [flush.icon]
    goto [iconloop]


[put.color]  'color working area and preview area
    modifyFlag=1    'icon has been modified
    if MouseX/10 = int(MouseX/10) then [iconloop] 'mouse is on grid line
    if MouseY/10 = int(MouseY/10) then [iconloop] 'mouse is on grid line
    x1=MouseX
    y1=MouseY

    IF changeall=0 THEN 'one pixel only
    'check for black; black doesn't flood fill correctly
    calldll #gdi32, "GetPixel",iconhdc AS long, x1 AS long,y1 AS long, CheckColor AS long
    if CheckColor=0 then
        print #main.g, "place ";int(x1/10)*10;" ";int(y1/10)*10;" "
        print #main.g, "boxfilled ";int(x1/10)*10+11;" ";int(y1/10)*10+11;" "
    else 'for colors other than black
        calldll #gdi32, "FloodFill", iconhdc as long, x1 as long, y1 as long, cl as long, results as long
    end if
    iconX=int(((x1-60)/10)+5)
    iconY=int((y1/10)+200)

    calldll #gdi32, "GetPixel",iconhdc as long, x1 as long,y1 as long, PixColor AS long
    calldll #gdi32, "SetPixel",iconhdc as long, iconX as long, iconY as long, PixColor as long, result as long
    end if


    IF changeall=1 THEN   'all instances, evaluate each pixel and change if it is the right color
    calldll #gdi32, "GetPixel",iconhdc as long, x1 as long,y1 as long, CheckColor AS long
    for y1=315 to 5 step -10
        for x1=65 to 375 step 10
            gosub [get.pixel]

            if PixColor=CheckColor then
            if CheckColor=0 then
                print #main.g, "place ";int(x1/10)*10;" ";int(y1/10)*10;" "
                print #main.g, "boxfilled ";int(x1/10)*10+11;" ";int(y1/10)*10+11;" "
            else
                calldll #gdi32, "FloodFill", iconhdc as long, x1 as long, y1 as long, cl as long, results as short
            end if
            end if

            iconX=int(((x1-60)/10)+5)
            iconY=int((y1/10)+200)
            calldll #gdi32, "GetPixel",iconhdc as long, x1 as long,y1 as long, PixColor AS long
            calldll #gdi32, "SetPixel",iconhdc as long, iconX as long, iconY as long, PixColor as long, result as long
        next x1
    next y1

    END IF


    if changeall=2 then 'flood fill small icon, then StretchBlt to big one, add grid
        if MouseX/10 = int(MouseX/10) then [iconloop] 'mouse is on grid line
        if MouseY/10 = int(MouseY/10) then [iconloop] 'mouse is on grid line
        x1=MouseX
        y1=MouseY
        calldll #gdi32, "GetPixel",iconhdc as long, x1 as long,y1 as long, CheckColor AS long
            iconX=int(((x1-60)/10)+5)
            iconY=int((y1/10)+200)
            calldll #gdi32, "ExtFloodFill", iconhdc as long, iconX as long, iconY as long, CheckColor as long,1 as short, results as short
        CallDll #gdi32, "StretchBlt",iconhdc as long,60 as long, 0 as long,320 as long, 320 as long,iconhdc as long, 5 as long, 200 as long, 32 as long, 32 as long, _SRCCOPY as ulong, r as long
        gosub [grid]
    end if
    gosub [flush.icon]
    goto [iconloop]



[flush.icon]
    print #main.g, "getbmp iconbmp 0 0 450 350"
    print #main.g, "segment newID"
    print #main.g, "drawbmp iconbmp 0 0;flush"
    print #main.g, "delsegment ";oldID
    oldID=newID
    print #main.g, "discard"
    return


[iconopen]  'open icon and display as is, and in drawing grid
    if modifyFlag=1 then
        confirm "Save current work as icon?";answer$
        if answer$="yes" then gosub [iconsavesub]
    end if

    gosub [clear]
    filedialog "Open",justPath$+"*.ico;*.exe;*.dll;*.icl;*.bmp",FileName$
    if FileName$="" then [iconloop]

    justPath$=SeparatePath$(FileName$)
    justName$=SeparateFile$(FileName$)

    if FileExist(justPath$,justName$)<1 then
        notice "Cannot find ";justName$
        goto [iconloop]
    end if

    fileext$=lower$(right$(FileName$,3))
    if fileext$="bmp" then [openbmp]

    File$=FileName$+chr$(0)

    indexicon = 0 or -1
    open "shell32" for dll as #shell
    calldll #shell, "ExtractIconA",hCurrentInst as long, File$ as ptr, indexicon as long,numbericons as long
        close #shell
    if numbericons > 1 then
        goto [iconpreview]
    else
        open "shell32" for dll as #shell
        calldll #shell, "ExtractIconA",hCurrentInst as long, File$ as ptr, 0 as long,hicon as long
        close #shell
    end if

    gosub [clear]
    gosub [display.icons]
    gosub [reduce]
    gosub [stretch] 'draw large copy
    gosub [grid]    'draw grid over large copy
    gosub [print.name]
    gosub [flush.icon]
    modifyFlag=0
    goto [iconloop]


[biconsave]'save as bitmap
    filedialog "Save as...","*.bmp",iconbmpfile$
    if iconbmpfile$="" then [iconloop]
    if lower$(right$(iconbmpfile$,4))<>".bmp" then
        iconbmpfile$=iconbmpfile$+".bmp"  'add bmp extension
    end if

    print #main.g, "getbmp iconbmp 5 200 32 32"
    BMPSAVE "iconbmp",iconbmpfile$
    notice "Image saved as ";iconbmpfile$
    goto [iconloop]

[iconsave]
    gosub [iconsavesub]
    goto [iconloop]

[iconsavesub]'get icon info into string and write to disk
    filedialog "Save as...","*.ico",savefile$
    if savefile$="" then return
    if lower$(right$(savefile$,4))<>".ico" then
        savefile$=savefile$+".ico"  'add ico extension
    end if
    modifyFlag=0

    cursor hourglass
    bits$="" 'reset string to hold bit information
    mask$=""

    x2=5:y2=232  'get fresh copy for saving
    for y1=315 to 5 step -10
        for x1=65 to 375 step 10
            gosub [get.pixel]
            gosub [draw.new.icon]
            gosub [add.to.file]
        next x1
    next y1

    gosub [write.file]
    gosub [write.disk]
    cursor normal
    return


[add.to.file]  'check color and add bit to bit string
    for j=0 to 15
        if PixColor=k(j) then
            bits$=bits$+k$(j)
            exit for
        end if
    next j

    if j=16 then
        PixColor=k(14)
        bits$=bits$+k$(14)
    end if

    if PixColor = k(12) and icopaque=0 then mask$=mask$+"1" else  mask$=mask$+"0"
    return


[write.file]'create string from header info, bit info and mask info
    saveicon$="" 'reset
    for i = 1 to 126
        saveicon$=saveicon$+chr$(header(i))
    next i

    for i = 1 to 1024 step 2
        saveicon$=saveicon$+chr$(hexdec(mid$(bits$,i,1)+mid$(bits$,i+1,1)))
    next i

    if icopaque=1 then
        for i = 1 to 128
            saveicon$=saveicon$+chr$(0)
        next i
    end if

    if icopaque=0 then
      for i = 1 to 1024 step 8
        maskval=0
        if mid$(mask$,i,1)="1" then maskval=128
        if mid$(mask$,i+1,1)="1" then maskval=maskval+64
        if mid$(mask$,i+2,1)="1" then maskval=maskval+32
        if mid$(mask$,i+3,1)="1" then maskval=maskval+16
        if mid$(mask$,i+4,1)="1" then maskval=maskval+8
        if mid$(mask$,i+5,1)="1" then maskval=maskval+4
        if mid$(mask$,i+6,1)="1" then maskval=maskval+2
        if mid$(mask$,i+7,1)="1" then maskval=maskval+1
        saveicon$=saveicon$+chr$(maskval)
      next i
    end if
    cursor normal
    return

[write.disk]'write saveicon$ to savefile$ on disk
    open savefile$ for binary as #sf
        print #sf, left$(saveicon$,766)
    close #sf
    notice "File saved as "+lower$(savefile$)
    RETURN


[runtimeIcon]'write current icon to runtime engine
    cursor hourglass
    bits$="" 'reset string to hold bit information
    mask$=""

    x2=5:y2=232  'get fresh copy for saving
    for y1=315 to 5 step -10
        for x1=65 to 375 step 10
            gosub [get.pixel]
            gosub [draw.new.icon]
            gosub [add.to.file]
        next x1
    next y1
    gosub [write.file]  'get file into saveicon$

    if len(saveicon$)<744 then end
    saveicon$=left$(saveicon$,766)

    filedialog "Choose runtime engine","*.exe",runexe$
    if runexe$="" then wait

    open runexe$ for binary as #bin
    seek #bin, 21664
    print #bin, right$(saveicon$,744)
    close #bin
    notice "Icon has been included in ";runexe$
    wait


[draw.new.icon] 'update lower view icon
    calldll #gdi32,"SetPixel",iconhdc as long,x2 as long, y2 as long,PixColor as long,result as long
    x2=x2+1
    if x2>=37 then x2=5:y2=y2-1
    RETURN


[get.pixel] 'get pixel color from large grid icon
    calldll #gdi32, "GetPixel",iconhdc as long,x1 as long,y1 as long,PixColor AS long
    RETURN

[display.icons]
    if hicon>1 then 'draw icon as is, and in small dynamic drawing view
        calldll #user32, "DrawIcon",iconhdc as long,5 as long,5 as long, hicon as long,Ret as long
        calldll #user32, "DrawIcon",iconhdc as long,5 as long,200 as long, hicon as long,Ret as long
    End if
    RETURN

[reduce]    'reduce to 16 colors on lower small icon
    for nx=5 to 37
        for ny=200 to 232
    calldll #gdi32, "GetPixel",iconhdc as long,nx as long,ny as long,OldColor AS long
    NewCol=GetNewCol(OldColor)
    calldll #gdi32, "SetPixel",iconhdc as long, nx as long, ny as long, NewCol as long, re as long
        next
    next
    return


[stretch]   'draw large copy
    'stretchblt icon to large version for drawing grid:
    calldll #gdi32,"StretchBlt",iconhdc as long, 60 as long, 0 as long,320 as long, 320 as long,_
        iconhdc as long,5 as long, 200 as long,32 as long,32 as long, _SRCCOPY as ulong,r as long
    RETURN

[grid]  'draw grid over large icon
    print #main.g, "down;color ";gridred;" ";gridgreen;" ";gridblue;" ;size 1"
    for x=60 to 380 step 10
        print #main.g, "line ";x;" 0 ";x;" 320"
    next x

    for y=0 to 320 step 10
        print #main.g, "line 60 ";y;" 380 ";y
    next y
    print #main.g, "color ";gridred;" ";gridgreen;" ";gridblue;
    print #main.g, "place 4 199;box 38 233"
    print #main.g, "backcolor white;place 5 250;\icon\view"
    print #main.g, "place 5 135;|color"
    print #main.g, "place 5 50;|original"
    print #main.g, "place 4 4;box 37 37"
    print #main.g, "backcolor ";backcolor$
    RETURN


[print.name]    'display filename
    print #main.g, "backcolor white"
    print #main.g, "place 5 340;|";FileName$+space$(100)
    RETURN

[iconnew] 'clear screen, draw grid, start new icon
    if modifyFlag=1 then
        confirm "Save current work as icon?";answer$
        if answer$="yes" then gosub [iconsavesub]
    end if
    modifyFlag=0
    FileName$="UNTITLED.ICO"
    gosub [clear]
    gosub [grid]
    gosub [print.name]
    goto [iconloop]

[clear] 'erase icons for new start
    print #main.g, "place 0 0;color white;backcolor white;boxfilled 381 321"
    gosub [flush.icon]
    RETURN


[iconhelp]
    msg$="Either open an existing icon, or begin drawing a new icon. " + _
        "You may also open a bmp file, which will be scaled to 32x32.  " + _
        "Images will be reduced to 16 colors. " + chr$(13) + chr$(13) + _
        "Click on the drawing color desired.  Click and drag the mouse in " + _
        "the grid to color the icon. " + chr$(13) + chr$(13) + _
        "Icons may be saved to disk as bitmap files or as icon files.  " + _
        "White can be the transparent color or you may choose to make it opaque." + _
        "  Fill mode can be set to fill a pixel at a time, or to change all " + _
        "instances of the color clicked, or to flood fill an area." +chr$(13) + chr$(13) + _
        "The icon in the display can be written into a copy of the runtime engine " + _
        "by clicking the 'Runtime Icon' button."
    notice "Help"+chr$(13)+msg$
    goto [iconloop]

[iconabout]
    about$="16-Color Icon Tool for Liberty BASIC 3  "+chr$(169)+" Alyce Watson, 2002."
    confirm about$ + "  Send feedback to Alyce Watson?";answer$
    if answer$="yes" then call RunThis "mailto:alycewatson@charter.net",Handle
    goto [iconloop]


[iconpreview]
    iconindex=0
    WindowWidth=240:WindowHeight=230
    iconmsg$="There are "+str$(numbericons)+" in the file.  Choose one please!"
    statictext #p.s, "", 10,10,200,50
    statictext #p.p, "Index 0",10,120,100,30
    button #p.default, "Okay",[previewdone],     UL,120,70,100,30
    button #p.next, "Next >>",[nexticon],        UL,120,110,100,30
    button #p.prev, "<< Previous",[previousicon],UL,120,150,100,30
    graphicbox #p.g, 15,60,36,36
    open "Icon Preview" for dialog_modal as #p
    print #p.s, "!font arial 0 20"
    print #p.p, "!font arial 0 20"
    print #p.default, "!font arial 0 20"
    print #p.prev, "!font arial 0 20"
    print #p.next, "!font arial 0 20"

    print #p.s, iconmsg$
    print #p, "trapclose [previewdone]"
    hpre=hwnd(#p.g)
    CallDll #user32, "GetDC",hpre as word, prehdc as word

    goto [showiconpreview]
[iconpreviewloop]
    input a$

[previousicon]
    iconindex=iconindex-1
    if iconindex<0 then
        iconindex=0
        notice "This is the first icon in the file."
    end if
    goto [showiconpreview]

[nexticon]
    iconindex=iconindex+1
    if iconindex>numbericons-1 then
        iconindex=numbericons-1
        msg$="There are "+str$(numbericons)+" in the file with indexes of 0 - "+str$(numbericons-1)+" . This is the last icon in the file."
        notice msg$
    end if
    goto [showiconpreview]

[showiconpreview]
    print #p.g, "cls"
    print #p.p, "Index "+str$(iconindex)
    open "shell32" for dll as #shell
    calldll #shell, "ExtractIconA",hCurrentInst as long, File$ as ptr, iconindex as long,hicon as long
    close #shell
    calldll #user32, "DrawIcon",prehdc as long,0 as long,0 as long, hicon as long,Ret as long
    goto [iconpreviewloop]


[previewdone]
    CallDll #user32, "ReleaseDC", hpre as long, prehdc as long, r as long
    close #p
    gosub [clear]
    gosub [display.icons]
    gosub [reduce]
    gosub [stretch] 'draw large copy
    gosub [grid]    'draw grid over large copy
    gosub [print.name]
    gosub [flush.icon]
    modifyFlag=0
    goto [iconloop]


[iconexit]
    confirm "Save current work as icon?";answer$
    if answer$="yes" then gosub [iconsavesub]
    calldll #user32, "ReleaseDC", Handle as long, iconhdc as long, Ret as long
    close #main:end


[openbmp]'get dims, select into mem DC, StretchBlt to icon-size
    loadbmp "pix",FileName$
    hPix=hbmp("pix")
    bwide=BitmapWidth(hPix)
    bhigh=BitmapHeight(hPix)

    open "Select Area with Mouse" for graphics_nsb_nf as #2
    print #2, "down; drawbmp pix 0 0; flush"
    print #2, "rule xor"'; box ";bmpx2;" ";bmpy2
    print #2, "setfocus; when leftButtonDown [startBox]"
    print #2, "when leftButtonMove [moveBox]"
    print #2, "when leftButtonUp [endBox]"
    print #2, "trapclose [quitBmpPreview]"
    CURSOR crosshair
    wait

[startBox]
    if MouseX>bwide or MouseY>bhigh then wait
    bmpx1=MouseX:bmpy1=MouseY
    bmpx2=MouseX:bmpy2=MouseY
    print #2, "place ";bmpx1;" ";bmpy1
    print #2, "box ";bmpx2;" ";bmpy2
    wait

[moveBox]
    if MouseX>bwide or MouseY>bhigh then wait
    print #2, "place ";bmpx1;" ";bmpy1
    print #2, "box ";bmpx2;" ";bmpy2
    bmpx2=MouseX:bmpy2=MouseY
    print #2, "place ";bmpx1;" ";bmpy1
    print #2, "box ";bmpx2;" ";bmpy2
    wait

[endBox]
    bmpx2=MouseX:bmpy2=MouseY
    if bmpx2>bwide then bmpx2=bwide
    if bmpy2>bhigh then bmpy2=bhigh
    newbmpwide=abs(bmpx2-bmpx1)
    newbmphigh=abs(bmpy2-bmpy1)
    print #2, "when leftButtonDown"
    print #2, "when leftButtonMove"
    print #2, "when leftButtonUp"

    close #2
    cursor normal
    timer 50, [showbmp]
    wait

[showbmp]
    timer 0
    cursor normal
    calldll #gdi32, "CreateCompatibleDC",iconhdc as long, bmphdc as long
    CallDLL #gdi32,"SelectObject",bmphdc As long,hPix As long,result As long

    'draw two icon-sized copies of bmp:
    calldll #gdi32,"StretchBlt",iconhdc as long, 5 as long, 5 as long,32 as long, 32 as long,_
        bmphdc as long,bmpx1 as long, bmpy1 as long,newbmpwide as long,newbmphigh as long, _SRCCOPY as ulong,r as long
    calldll #gdi32,"StretchBlt",iconhdc as long, 5 as long, 200 as long,32 as long, 32 as long,_
        bmphdc as long,bmpx1 as long, bmpy1 as long,newbmpwide as long,newbmphigh as long, _SRCCOPY as ulong,r as long

    CallDLL #gdi32, "DeleteDC",bmphdc As long, r As boolean

    gosub [reduce]
    gosub [stretch] 'draw large copy
    gosub [grid]    'draw grid over large copy
    gosub [print.name]
    gosub [flush.icon]
    modifyFlag=0
    unloadbmp "pix"
    goto [iconloop]

[quitBmpPreview]
    CURSOR NORMAL
    unloadbmp "pix"
    close #2
    goto [iconloop]


function SeparateFile$(f$)
    fileindex=len(f$)
    filelength=len(f$)
      while mid$(f$, fileindex,1)<>"\"
        fileindex=fileindex-1
      wend
    SeparateFile$=right$(f$,filelength-fileindex)
end function


function SeparatePath$(f$)
    fileindex=len(f$)
    filelength=len(f$)
      while mid$(f$, fileindex,1)<>"\"
        fileindex=fileindex-1
      wend
    SeparatePath$=left$(f$,fileindex)
end function


function FileExist(fPath$,fFile$)
    dim info$(10,10)
    files fPath$,fFile$,info$(
    FileExist=val(info$(0,0))
end function


sub RunThis RunFile$, hWindow
    RunFile$=RunFile$+chr$(0)
    lpOperation$ = "open" + chr$(0)
    lpParameters$ = "" + chr$(0)
    lpDirectory$ = "" + chr$(0)
    nShowCmd = _SW_SHOWNORMAL

    calldll #shell32, "ShellExecuteA", _
        hWindow as long, _          'parent window
        lpOperation$ as ptr, _      'open or print
        RunFile$ as ptr, _          'file name
        lpParameters$ as ptr, _     'null
        lpDirectory$ as ptr, _      'default directory
        nShowCmd as long, _        'show window flag
        result as long
    if result <= 32 then notice "Error, Address Failure!"
end sub


Function BitmapWidth(Hbmp)
    struct BITMAP,_
    bmType As long,_
    bmWidth As long,_
    bmHeight As long,_
    bmWidthBytes As long,_
    bmPlanes As word,_
    bmBitsPixel As word,_
    bmBits As long
    nSize=Len(BITMAP.struct)
    CallDLL #gdi32, "GetObjectA", Hbmp As long,_
       nSize As long,BITMAP As struct,_
       results As long
    BitmapWidth=BITMAP.bmWidth.struct
End Function

Function BitmapHeight(Hbmp)
    struct BITMAP,_
    bmType As long,_
    bmWidth As long,_
    bmHeight As long,_
    bmWidthBytes As long,_
    bmPlanes As word,_
    bmBitsPixel As word,_
    bmBits As long
    nSize=Len(BITMAP.struct)
    CallDLL #gdi32, "GetObjectA", Hbmp As long,_
       nSize As long,BITMAP As struct,_
       results As long
    BitmapHeight=BITMAP.bmHeight.struct
End Function

Function GetNewCol(col)
    r=GetRed(col)
    g=GetGreen(col)
    b=GetBlue(col)
    k(0)=16711935     'pink

    If r<70 Then r1=0
    If r>=70 and r<160 Then r1=127
    If r>=160 Then r1=255

    If g<70 Then g1=0
    If g>=70 and g<160 Then g1=127
    If g>=160 Then g1=255

    If b<70 Then b1=0
    If b>=70 and b<160 Then b1=127
    If b>=160 Then b1=255

    'for lightgray:
    If r>170 and r<212 Then
        If g>170 and g<212 Then
            If b>170 and b<212 Then
                r1=192
                g1=192
                b1=192
                goto [finish]
            End If
        End If
    End If

    'check for non-LB colors
    if r1=127 or g1=127 or b1=127 then
        'all dark gray:
        if r1=127 and g1=127 and b1=127 then [finish]

        'two black, 127 stays same
        if r1=0 and g1=0 then [finish]
        if r1=0 and b1=0 then [finish]
        if g1=0 and b1=0 then [finish]

        'two are white, so 127 becomes 0
        if r1=255 and g1=255 then b1=0:goto [finish]
        if r1=255 and b1=255 then g1=0:goto [finish]
        if g1=255 and b1=255 then r1=0:goto [finish]

        '1=255, 1=127, 1=0, so go with the one that is
        '255, set others to 0
        if r1=255 then b1=0:g1=0
        if g1=255 then r1=0:b1=0
        if b1=255 then r1=0:g1=0
    end if

    [finish]
    GetNewCol=k(12) 'just in case, set to white for default
    if r1=0   and g1=0   and b1=0   then GetNewCol=k(15)'black
    if r1=127 and g1=127 and b1=127 then GetNewCol=k(14)'darkgray
    if r1=192 and g1=192 and b1=192 then GetNewCol=k(13)'lightgray
    if r1=255 and g1=255 and b1=255 then GetNewCol=k(12)'white
    if r1=0   and g1=0   and b1=127 then GetNewCol=k(11)'darkblue
    if r1=0   and g1=0   and b1=255 then GetNewCol=k(10)'blue
    if r1=0   and g1=127 and b1=0   then GetNewCol=k(9) 'darkgreen
    if r1=0   and g1=255 and b1=0   then GetNewCol=k(8) 'green
    if r1=0   and g1=127 and b1=127 then GetNewCol=k(7) 'darkcyan
    if r1=0   and g1=255 and b1=255 then GetNewCol=k(6) 'cyan
    if r1=127 and g1=127 and b1=0   then GetNewCol=k(5) 'brown
    if r1=255 and g1=255 and b1=0   then GetNewCol=k(4) 'yellow
    if r1=127 and g1=0   and b1=0   then GetNewCol=k(3) 'darkred
    if r1=255 and g1=0   and b1=0   then GetNewCol=k(2) 'red
    if r1=127 and g1=0   and b1=127 then GetNewCol=k(1) 'darkpink
    End Function

Function GetRed(color)
    blue=Int(color/(256*256))
    green=Int((color-blue*256*256)/256)
    GetRed=color-blue*256*256-green*256
    End Function

Function GetGreen(color)
    blue=Int(color/(256*256))
    GetGreen=Int((color-blue*256*256)/256)
    End Function

Function GetBlue(color)
    GetBlue=Int(color/(256*256))
    End Function

Function GetPixel(hdc,x,y)
    calldll #gdi32, "GetPixel",hdc AS long,_
        x AS long,y AS long, GetPixel AS long
    End Function



